# Python Package for CITS algorithm: Causal Inference from Time Series data

CITS algorithm infers causal relationships in time series data based on structural causal model and Markovian condition of arbitrary but finite order.

## Installation

You can get the latest version of CITS package as follows

`pip install cits`

## Requirements

- Python >= 3.6
- R >= 4.0
- R package `kpcalg` and its dependencies. They can be installed in R or RStudio as follows:

```
> install.packages("BiocManager")
> BiocManager::install("graph")
> BiocManager::install("RBGL")
> install.packages("pcalg")
> install.packages("kpcalg")
```


## Documentation

[Documentation is available at readthedocs.org](https://cits.readthedocs.io/en/latest/)

## Tutorial

See the [Getting Started](https://cits.readthedocs.io/en/latest/gettingstarted.html) for a quick tutorial of the main functionalities of this library and check if it is installed properly. 

## Contributing

Your help is absolutely welcome! Please do reach out or create a future branch!

## Citation

Coming soon
